<template>
	<zj-tab-page ref="tabPage" :defaultActives="[{ key: 'list', label: $route.meta.title+'-列表', essential: true }]">
		<template slot-scope="{activeKey, data}">
			<template-page v-if="activeKey == 'list'" ref="pageRef" :get-list="getList" :table-attributes="tableAttributes" :table-events="tableEvents"
			  :options-evens-group="optionsEvensGroup" :moreParameters="moreParameters" :column-parsing="columnParsing"
			  :operation="operation()" :exportList="exportList">
				<div slot="moreSearch">
				  <el-radio-group v-model="type" size="mini" @change="changeType">
				    <el-radio-button :label="''">全部</el-radio-button>
				    <el-radio-button :label="true">开启</el-radio-button>
				    <el-radio-button :label="false">禁用</el-radio-button>
				  </el-radio-group>
				  <br><br>
				</div>
			</template-page>
			<div v-if="~['add', 'edit', 'detail'].indexOf(activeKey)">
				<zj-form-container ref="formRef" :form-data="formData" :styleSwitch="false">
				  <zj-form-module title="" label-width="110px" :showPackUp="false"
				    :form-data="formData" :form-items="formItems">
				  </zj-form-module>
				</zj-form-container>
				<div slot="footer" class="dialog-footer">
				  <el-button size="mini" @click="data.removeTab()">取 消</el-button>
				  <el-button v-if="formDialogType !== 2" size="mini" @click="formConfirm(data.removeTab)" type="primary">确 定</el-button>
				</div>
			</div>
		</template>
	</zj-tab-page>
</template>

<script>
import TemplatePage from '@/components/template/template-page-1.vue'
import import_mixin from '@/components/template/import_mixin.js'
import { required, mobileRequired, mobile } from '@/components/template/rules_verify.js'
import { chargingStandardList3, chargingStandardList3PageExport, chargingStandardImport, getMainList, getMainDetail, saveMain, deleteMain, getBrandList } from "@/api/miniapp";
import { getClassifyList } from '@/api/goods'
import { downloadFiles } from '@/utils/util'
import operation_mixin from '@/components/template/operation_mixin.js'
export default {
  components: { TemplatePage },
  mixins: [import_mixin,operation_mixin],
  data() {
    return {
      type: "",
      // 表格属性
      tableAttributes: {
        // 启用勾选列
        selectColumn: false
      },
      // 表格事件
      tableEvents: {
        'selection-change': this.selectionChange
      },
      // 勾选选中行
      recordSelected: [],
      /** 表单变量 */
      formDialogType: 0,
      formDialogTitles: ["新增", "编辑", "查看"],
      formDialog: false,
      formData: {
        brandId: "",
        oneCategoryId: "",
        twoCategoryId: "",
        content1: "",
        content2: "",
        status: true,
      },
      brandList: [], // 品牌列表
      mainList: [], // 一级分类列表
      smallList: [], // 二级分类列表
			formType: 'add',
			formVisible: false,
    }
  },
  computed: {
	// 事件组合
	optionsEvensGroup() {
		return [
			[
				[
					this.optionsEvensAuth("add", {
						click: () => {
							this.openForm('add')
						}
					})
				],
			],
			[
				[
					this.optionsEvensAuth("template", {
						click: () => {
							this.handleDownload()
						}
					})
				],
			],
			[
				[
					this.optionsEvensAuth("imp", {
						render: () => {
						  return this.importButton(chargingStandardImport, '导入模板')
						}
					})
				],
			]
		]
	},
    // 更多参数
    moreParameters() {
      return []
    },
    formItems() {
      return [
        {
          md: 6,
          isShow: true,
          name: 'el-select',
          options: this.brandList,
          attributes: { filterable: true, placeholder: '请选择', disabled: this.formDialogType == 2, },
          formItemAttributes: {
            label: '服务品牌',
            prop: 'brandId',
            rules: [...required]
          }
        },
        {
          md: 6,
          isShow: true,
          name: 'el-select',
          options: this.mainList,
          attributes: { filterable: true, placeholder: '请选择', disabled: this.formDialogType == 2, },
          formItemAttributes: {
            label: '一级分类',
            prop: 'oneCategoryId',
            rules: [...required]
          },
          events: {
            change: async val => {
              this.smallList = []
              this.formData.twoCategoryId = ""
              if (val) {
                this.smallList = this.mainList.find(item => {
                  return item.value == val;
                })?.data?.children?.map(item => ({
                  label: item.name,
                  value: item.categoryId,
                  data: item
                })) || [];
              }
            }
          }
        },
        {
          md: 6,
          isShow: true,
          name: 'el-select',
          options: this.smallList,
          attributes: { filterable: true, placeholder: '请选择', disabled: this.formDialogType == 2, },
          formItemAttributes: {
            label: '二级分类',
            prop: 'twoCategoryId',
            rules: [...required]
          }
        }, {
          md: 6,
          isShow: true,
          name: 'el-input',
          attributes: { placeholder: '请输入', disabled: this.formDialogType == 2, },
          formItemAttributes: {
            label: '故障内容',
            prop: 'content1',
            rules: [...required]
          }
        },
        {
          md: 6,
          isShow: true,
          name: 'el-radio',
          options: [{ label: "开启", value: true }, { label: "禁用", value: false }],
          attributes: { filterable: true, placeholder: '请选择', disabled: this.formDialogType == 2 },
          formItemAttributes: {
            label: '状态',
            prop: 'status',
            rules: [...required]
          }
        },
		{
		  md: 24,
		  isShow: true,
		  name: 'el-input',
		  attributes: { placeholder: '请输入', type: "textarea", rows: 5, disabled: this.formDialogType == 2, },
		  formItemAttributes: {
		    label: '故障排除指引',
		    prop: 'content2',
		    rules: [...required]
		  }
		}
      ]
    }
  },
  methods: {
    // 切换状态
    changeType(val) {
      this.$refs.pageRef.refreshList()
    },
    // 列表请求函数
    getList(p) {
      try {
        var pam = JSON.parse(JSON.stringify(p))
        if (this.type !== '') {
          pam.params.push({ "param": "a.status", "compare": "=", "value": this.type })
        }
        return chargingStandardList3(pam)
      } catch (error) {
        console.log(error)
      } finally {

      }
    },
    // 列表导出函数
    exportList: chargingStandardList3PageExport,
    // 表格列解析渲染数据更改
    columnParsing(item, defaultData) {
      return defaultData
    },
    // 监听勾选变化
    selectionChange(data) {
      this.recordSelected = data
    },
	// 表格操作列
	operation() {
		return this.operationBtn({
			detail: {
				btnType: 'text',
				click: ({ row, index, column }) => {
					this.openForm('detail',row.id)
				}
			},
			edit: {
				btnType: 'text',
				click: ({ row, index, column }) => {
					this.openForm('edit',row.id)
				}
			},
			del: {
				btnType: 'text',
				prompt: '确定删除吗？',
				click: ({ row, index, column }) => {
					deleteMain({ id: row.id }).then(res => {
					  this.$message({
					    type: 'success',
					    message: `删除成功!`,
					  })
					  this.$refs.pageRef.refreshList()
					})
				}
			}
		})
	},
    // 取消 新增编辑
    formCancel() {
      this.formVisible = false
      this.$refs?.formRef?.resetFields()
      this.$data.formData = this.$options.data().formData
    },
    // 打开 新增编辑 网点表单
    openForm(type, id) {
      this.$refs.tabPage.addTab({
        // 对应显示的模块
        activeKey: type,
        // 唯一标识
        key: type,
        // 页签名称
        label: ({ edit: "编辑", add: "新增", detail: "查看" })[type],
        // 打开时事件
        triggerEvent: () => {
          this.formCancel()
          this.$nextTick(()=>{
            this.formType = type
            this.formVisible = true
            if (type == 'add') {
              this.formDialogType = 0
				this.initData()
            } else if(type == 'edit'){
    			this.formDialogType = 1
    			getMainDetail({ id }).then(res => {
    			  Object.assign(this.formData, res.data)
    			  this.initData()
    			})
            }else{
    			this.formDialogType = 2
				getMainDetail({ id }).then(res => {
					Object.assign(this.formData, res.data)
					this.initData()
				})
    		}
          })
        },
        // 关闭时事件
        closeEvent: () => {
          
        }
      })
    },
    initData() {
      Promise.all([
        getBrandList(),
        getClassifyList({
          type: 2,
          name: '',
        })
      ]).then(([res2, res3]) => {
        this.brandList = res2.data.map(item => ({
          label: item.brandName,
          value: item.id,
          data: item
        }));
        this.mainList = res3.data.map(item => ({
          label: item.name,
          value: item.categoryId,
          data: item
        }));
        if (this.formData.oneCategoryId) {
          this.smallList = this.mainList.find(item => {
            return item.value == this.formData.oneCategoryId;
          })?.data?.children?.map(item => ({
            label: item.name,
            value: item.categoryId,
            data: item
          })) || [];
        }
        this.formDialog = true;
      })
    },
    formConfirm(cancel) {
      this.$refs.formRef.validate((valid, invalidFields, errLabels) => {
        if (valid) {
          saveMain({...this.formData, type:2}).then(res => {
            this.$message({
              type: 'success',
              message: this.formDialogTitles[this.formDialogType] + `成功!`,
            })
            cancel('list')
            this.$refs.pageRef.refreshList()
          })
        }
      })
    },
    // 下载导入模版
    handleDownload() {
      downloadFiles('charging/standard/download');
    },
  }
}
</script>

<style lang="scss" scoped></style>
